require "fileutils"

module Dorian
  class Dot
    def self.run
      if ARGV.size < 1 || ARGV.size > 2 || ARGV[0] == "--help" || ARGV[0] == "-h"
        puts "USAGE: dot DIRECTORY [--confirm]"
        exit
      end

      dir = ARGV[0]
      confirm = ARGV[1] == "--confirm"
      files = Dir.glob("#{dir}/**/*", File::FNM_DOTMATCH)
      files = files.grep_v(/\/.git\//).grep_v(/\/\.$/).grep_v(/\/\.\.$/)
      files = files.select { |file| File.file?(file) }
      files.each do |file|
        file = file.gsub("//", "/")
        barefile = file.gsub(dir, "").gsub(/^\//, "")
        homefile = "#{Dir.home}/#{barefile}".gsub("//", "/")

        if File.exists?(homefile)
          if confirm
            FileUtils.rm(homefile)
          else
            print "#{homefile} file exists, delete? (y/N) "
            answer = confirm ? "yes" : $stdin.gets.strip

            if answer[0].to_s.downcase == "y"
              FileUtils.rm(homefile)
            else
              exit
            end
          end
        end

        FileUtils.ln_s(file, homefile, verbose: true)
      end
    end
  end
end
